
/*------------------ PROTOCOLLO DBTMA/FAMA (ULTIMA MODIFICA)-----------------*/

#include <stdlib.h>/*per exit(), rand(), .......    */
#include <iostream.h> /* per NULL   */
#include <math.h> /* per le funzioni per la creazione della topologia */
#include <time.h>
int simul_time;  /* per la chiamata delle funzioni */
int last_tx_time;
static int  num_rts,pkt_try_to_send_dir,pkt_try_to_send_bro , pkt_arrived_dir,pkt_arrived_bro,pkt_bro_not,interrupt_bro,pkt_b_tra,yes_cts,not_cts,yes_rts,not_rts,num_xmit_cts,rts_tra,btx_tra,data_tx,dirty_cts;
const int NUMERO_SLOT = 5;  /* #############*/ /* DA DEFINIRE*/
const int  T_MAX =1 ;
const int L_RTS = 12/*T_MAX*/;  //    lunghezze
const int L_CTS = 25/*T_MAX*/;    //       dei
const int L_DATA =25/*T_MAX*/;     //   pacchetti in
const int L_PKT_B = 25/*T_MAX*/;     //    questione
const int L_ANSWER = 12;
const int MAX_AREA = 10;
const float R_MAX = 2.0;
const int DELTA_TIME = 1/*T_MAX*/; /*intervallo tra due possibili tx successive */
const int ELAB_TIME = 0;
const int NUMERO_PROVE = 1;
enum CHANNEL_STATE {idle, busy};
enum FLAG {n,y};
enum NODE_STATE { n_passive , n_backoff , n_xmitrts,n_rts,n_xmitcts,n_rxctsfromrts,n_xmitdata, n_xmitbroad,  n_xmitpktb,n_xmitanswer,n_waitpktb, n_remote ,n_rxfromremote};
enum PKT_TO_SEND {not ,yes };
enum PKT_RIC {r_rts , r_cts, r_data, r_noise , r_pkt_b};
enum KIND_SGN { direct , broadcast };
enum SET_FLAG {not_ok , ok};  /* per generazione nodo che deve tx */
KIND_SGN sgn;
SET_FLAG set_tx_flag,one_bro;/* per generazione nodi che tx */
float dir_throug ;
float bro_throug ;



class channel
{
  public :
   CHANNEL_STATE state;
};


class nodo
{
 public :
  NODE_STATE n_state;
  int  node_id;
  int num_vicini;
  int coord_x,coord_y;
  int brx_act_count ;/*-- devono essere inizializzati a 0 ? ------ */
  int btx_id;
  int brx_id ; /*-- per sgn broad. in cluster vicini */
  int btx_act_count ;/*-- "         "         "         "   ------ */
  int pkt_ric_id; /* indica il campo del pkt con l'id della dest. */
  int dest_node_id; /* indica il nodo dest. del pkt       */
  int L_NOISE;
  int timer,timer2,remote_time;
  PKT_TO_SEND pkt_to_tx;
  KIND_SGN kind_of_sgn;
  FLAG dflag,flag ,flag2 , flag3 ,flag4,str,broad_off_flag, wait_flag ,wait_for_pkt_b_flag,pkt_b_ok_flag,broad_ok ,back_flag;
  PKT_RIC kind_pkt_ric, initial_pkt_ric;
  int* vett_vicini;
  channel ccch,btxcch,brxcch;
};

/*------------------------fine definizioni---------------------------------*/
/*-------------- inserimento prototipi delle funzioni ---------------------*/

void passive(nodo*,int);
void backoff(nodo*,int);
void xmitrts(nodo*,int);
void rts(nodo*,int);
void rxctsfromrts(nodo*,int);
void xmit_cts(nodo*,int);
void xmit_data(nodo*,int);
void xmit_broad(nodo*,int);
void xmit_pkt_b(nodo*,int);
void xmit_answer(nodo*,int);
void wait_pktb(nodo* ,int);
void remote(nodo*,int);
void rx_from_remote(nodo*,int);

/*----------------- FINE DEI PROTOTIPI DLLE FUNZ. DEL PROTOCOLLO -------------*/

/*---FUNZIONI PER LA CREAZIONE DEL VETTORE DEI NODI E SUA INIZIALIZZAZIONE----*/
/*---- FUNZIONI NECESSARIE NELLE PROCEDURE SEGUENTI --------------------*/


float node_distance(nodo* n1, nodo* n2)
{
 float distance;
 int k,m,n,l;
 k = (n1->coord_x);
 m = (n2->coord_x);
 n = (n1->coord_y);
 l = (n2->coord_y);
 distance = sqrt( pow((k-m), 2) +pow((n-l), 2));
 return distance;
}

/*-------------- FINE FUNZIONI AUSILIARIE --------------------------*/


/*-------- PROCEDURA DI CREAZIONE DEL VETTORE DEI NODI ------------*/

nodo* crea_vettore_rete(int numero_nodi)
{
 int i;
 nodo* p = new nodo[numero_nodi];
 if( p== NULL)
 {
  cout << "non  stata allocata memoria per p. \n";
  exit(EXIT_FAILURE);
 }
 for(i=0;i<numero_nodi;i++) // fase inizializzazione dei campi del
 {                          // del vettore dei nodi escluse le coord
  (p+i)->node_id = i;
  (p+i)->n_state = n_passive;
  (p+i)->brx_act_count = 0;
  (p+i)->btx_act_count = 0;
  (p+i)->btx_id =0;
  (p+i)->brx_id =0;
  (p+i)->timer = 0;
  (p+i)->timer2 = 0;
  (p+i)->remote_time = 0;
  (p+i)->pkt_to_tx = not;
  (p+i)->flag = n;
  (p+i)->flag2 = n;
  (p+i)->flag3 = n;
  (p+i)->flag4 = n;
  (p+i)->broad_ok = n;
  (p+i)->wait_for_pkt_b_flag = n;
  (p+i)->pkt_b_ok_flag = n;
  (p+i)->broad_off_flag = n;
  (p+i)->wait_flag = n;
  (p+i)->back_flag = n;
  (p+i)->ccch.state = idle;
  (p+i)->btxcch.state = idle;
  (p+i)->brxcch.state = idle;
 }
 return p;
}

/*------------- FINE CREAZIONE DEL VETTORE DEI NODI -------------------*/


/*-------- PROCEDURA DI CREAZIONE DELLA TOPOLOGIA -------------------*/
/* ------ NUOVA PROCEDURA DI ASSEGNAZIONE DELLE COORDINATE-----------*/

void assign_coordinate(nodo* p, int numero_nodi)
{
 int i , j , num_nodi_act = 0;
 int* matrix;
 matrix = new int[(MAX_AREA)*(MAX_AREA)];
 if( matrix == NULL )
 {
  cout << "memoria non allocata per matrix. \n";
  exit(EXIT_FAILURE);
 }
 for(i=0;i<MAX_AREA;i++)
 {
  for(j=0;j<MAX_AREA;j++)
   *(matrix +i*MAX_AREA + j) = 0;  // INIZIALIZZAZIONE DELLA MATRICE
 } // FINE CICLI DI INIZIALIZZAZIONE
 randomize();// messo qui il tempo per la generazione delle coord  molto minore
 while(num_nodi_act < numero_nodi)
 {
  i = random(MAX_AREA);   // RESTITUISCE INTERO TRA 0 E (MAX_AREA-1)
  j = random(MAX_AREA);
  if(*(matrix +i*MAX_AREA + j) == 0)   // CREAZIONE MATRICE RANDOM
  {                                    // PER L'ASSEGNAZIONE DELLE COORDINATE
   *(matrix + i*MAX_AREA +j) = 1;
   num_nodi_act ++;
  }
 }
 num_nodi_act = 0;
 do
 {
  for(i=0;i<MAX_AREA;i++)
  {
   for(j=0;j<MAX_AREA;j++)
   {
    if(*(matrix + i*MAX_AREA  + j) == 1)
    {
     (p + num_nodi_act)->coord_x = i;
     (p + num_nodi_act)->coord_y = j;
     num_nodi_act ++;
    }
   }
  }
 } // FINE BLOCCO DO
 while(num_nodi_act < numero_nodi); // FINE ASSEGNAZIONE COORDINATE
 delete(matrix);
}

/*---- FINE DELLA PROCEDURA DI ASSEGNAZIONE DELLE COORDINATE --------*/

/*------- PROCEDURA PER RIEMPIMENTO CAMPI DEL VETT_VICINI ---------------*/


void make_vett_vicini(nodo* p, int numero_nodi)
{
 int i,tot_vicini,j,temp;
 for(i=0;i<numero_nodi;i++)
 {
  tot_vicini=0;
  for(j=0;j<numero_nodi;j++)
  {
   if(i != j)
   {
    if(node_distance((p+i) , (p+j)) <= R_MAX )
     tot_vicini++;
   }
  } // del for j
  (p+i)->num_vicini = tot_vicini;
  if(tot_vicini >= 1)                           // SE k> 0 NON VIENE ALLOCATO IL VETTORE DEI VICINI
  {                                    // IL CONTROLL0 VA ESEGUITO OGNI VOLTA CHE SI DEVONO ATTIVARE I CAMPI
   (p+i)->vett_vicini = new int[tot_vicini]; // DEI VICINI SIA in tx che in rx
   temp=(tot_vicini-1);
   for(j=0;j<numero_nodi;j++)
   {
    if(i != j)
    {
     if(node_distance((p+i) , (p+j)) <= R_MAX )
     {
      (p+i)->vett_vicini[temp] = j;
      temp--;
     }
    } //del if i != j
   } // del for j
  } // del if k>=1
 }// del for i
} // fine make_vett

/*------- FINE PROCEDURA RIEMPIMENTO VETT_VICINI PER TUTTI I NODI --------*/


/*-------- INIZIO DELLE PROCEDURE VERE E PROPRIE CHE ESEGUONO IL PROTOCOLLO --*/

/* --------------------- PROCEDURA PASSIVE --------------------------------*/

void passive(nodo* p, int nid )
{
 (p+nid)->n_state = n_passive;
 if(( (p+nid)->ccch.state == idle )&&((p+nid)->btxcch.state == idle)&&((p+nid)->pkt_to_tx  == not))
 {
  (p+nid)->wait_flag = y;
  return;
 }
 else if(((p+nid)->btxcch.state == busy))
 {
  remote( p,nid ); // ARGOMENTI DI DEFAULT-(2*T_MAX + L_DATA,0)-attesa del pkt_b-
 }
 else if((p+nid)->ccch.state == busy) // ----------attesa di rx sul ccch------
 {
  (p+nid)->dflag = n;// INIZIALIZZAZIONE DEL DFLAG PER LE CHIAMATE DI REMOTE
  (p+nid)->remote_time = L_DATA + (2*(2*T_MAX))+ELAB_TIME;
  remote( p,nid );// VEDI REGOLE FAMA = arg. di default
 }
 else // ------- pkt_to_tx = yes-------------------------------
 {
  if((p+nid)->brxcch.state == idle) // CONDIZIONE PER POTER TRASM. IN CASO DI PRESENZA DI TX BROAD.
  {
   if((p+nid)->kind_of_sgn == direct)
   {
    xmitrts( p,nid );//  inutile dargli il nodo dest. dato che  settato al momento della generazione della tx
   }
   else // ------r->sgn  di tipo broad---------------------------------
   {
    xmit_broad( p,nid );// ----deve essere integrata l'attivazione della get_btx------
   }
  } // FINE CONDIZIONE BRXCCH = IDLE
  else // BRX OCCUPATO , QUINDI TX BROAD IN CORSO
  {
   (p+nid)->dflag = y;
   (p+nid)->remote_time = L_DATA + 2*T_MAX+ELAB_TIME;
   remote(p,nid);
  }
 }// ------ fine pkt_to_tx = yes---------------------------------
} /* ------------- FINE PROCEDURA ------------------------------------*/

/*------------------- PROCEDURA BACKOFF -------------------------------*/

void backoff(nodo*p, int nid)
{
 (p+nid)->n_state = n_backoff;
 if((p+nid)->back_flag == n)  // flag utile per prima attivazione del tempo di backoff
 {
  (p+nid)->timer = simul_time +1+(random(3)*L_ANSWER) ; // K da definire
  (p+nid)->back_flag = y;
 }
 if(((p+nid)->ccch.state == idle)&&((p+nid)->btxcch.state == idle)&&(simul_time < (p+nid)->timer))
 {
  (p+nid)->wait_flag = y;
  return;
 }
 else if(((p+nid)->btxcch.state == busy))
 {
  (p+nid)->back_flag = n;
  remote(p,nid); // ARGOMENTI DI DEFAULT per toni btx e brx
 }
 else if((p+nid)->ccch.state == busy)
 {
  (p+nid)->back_flag = n;
  (p+nid)->dflag = n;// INIZIALIZZAZIONE DEL DFLAG PER LE CHIAMATE DI REMOTE
  (p+nid)->remote_time = L_DATA + (2*(2*T_MAX))+ELAB_TIME;
  remote(p,nid ); //	VEDI REGOLE FAMA
 }
 else // timer scaduto
 {
  if((p+nid)->brxcch.state == idle) // CONTROLLO PREVENTIVO SUL TONO BRX PRIMA DI TX
  {
   if((p+nid)->kind_of_sgn == direct)
   {
    (p+nid)->back_flag = n;
    xmitrts(p,nid);
   }
   else // sgn = broadcast
   {
    (p+nid)->back_flag = n;
    xmit_broad(p,nid);
   }
  }// FINE CONDIZIONE PER LA TX DEL RTS IN CASO DI TX BROAD
  else
  {
   (p+nid)->back_flag = n;
   (p+nid)->dflag = y;
   (p+nid)->remote_time = L_DATA + 2*T_MAX +ELAB_TIME;
   remote(p,nid);
  }
 } // fine dell'else timer scaduto
}/*----------------- FINE PROCEDURA --------------------------------------*/


/* -----------------------PROCEDURA XMIT_RTS ----------------------------*/

void xmitrts( nodo*p , int nid )
{
 int t,q;
 (p+nid)->n_state = n_xmitrts;
 if( (p+nid)->flag == n)
 {
  num_rts++;
  (p+nid)->timer =simul_time + L_RTS;
  (p+nid)->ccch.state = busy;
  (p+nid)->kind_pkt_ric = r_rts;          // Per il confronto alla fine della tx per
  (p+nid)->flag = y;                     // mettere in idle il ccch
  (p+nid)->L_NOISE =(L_RTS-1);
  (p+nid)->wait_flag = y;                // SIMULA IL TEMPO DI PROPAGAZIONE
  return;
 }
 if( simul_time < (p+nid)->timer)        // tempo di tx del rts
 {
  if( (p+nid)->flag2 == n)
  {
   for(t=0;t<(p+nid)->num_vicini;t++)    // QUI IL CONTROLLO VIENE FATTO IN FASE DI GENERAZIONE
   {                                     // DELL'EVENTO TX
    q = (p+nid)->vett_vicini[t];
    if((p+q)->ccch.state == busy)
    {
     (p+q)->kind_pkt_ric = r_noise;
     if((p+q)->L_NOISE < L_RTS)          // per la durata del rumore
      (p+q)->L_NOISE = L_RTS;
    } //---------- if(p+t)->ccch = busy-----------------------------
    else
    {
     (p+q)->ccch.state = busy;
     (p+q)->kind_pkt_ric = r_rts;
     (p+q)->pkt_ric_id = (p+nid)->dest_node_id;
    }
   } //---------- fine ciclo for ------------------------------------
   (p+nid)->flag2 = y;
  } // --------------- fine if flag2 == n -------------------------
  (p+nid)->L_NOISE --;// PER TENERE SEMPRE AGGIORNATO IL CONT DI RUMORE
  (p+nid)->wait_flag = y;  // si attende la fine della tx del pkt RTS
  return;            // e poi eventualmente si controlla .....
 } // -------------FINITA LA TRASM. DELL'RTS -------------------------
 rts_tra ++; // CONTATORE RTS TRASMESSI
 if((p+nid)->kind_pkt_ric == r_rts)
 {
  (p+nid)->ccch.state = idle;    // per reset del canale e del rumore per la successiva ricez.
  (p+nid)->L_NOISE = 0;
 }
 (p+nid)->flag2 = n;  // viene utilizzato nella soub1
 (p+nid)->flag = n;
 rts(p,nid);
} // ------------- FINE PROCEDURA XMIT_RTS----------------------------

//--- INIZIO PROCEDURA RTS PER LA EVENTUALE RICEZIONE DEL CTS -------------

void rts(nodo* p, int nid)
{
 (p+nid)->n_state = n_rts;
 if((p+nid)->flag == n)
 {
  (p+nid)->timer = simul_time + (2*(2*T_MAX)) +ELAB_TIME; // ATTESA DEL CTS
  (p+nid)->flag = y;
 }
 if(((p+nid)->ccch.state == idle)&&((p+nid)->btxcch.state == idle)&&(simul_time <= (p+nid)->timer))
 {
  (p+nid)->wait_flag = y;
  return;
 }
 else if(((p+nid)->btxcch.state == busy))
 {
  (p+nid)->flag2 = n; // forse non necessario
  (p+nid)->flag = n;
  remote(p, nid );//ARGOMENTI DI DEFAULT--att. brx e attesa pkt_b -(2*T_MAX + L_DATA , 0)
 }
 else if(simul_time > (p+nid)->timer)
 {
  (p+nid)->flag = n;
  (p+nid)->back_flag = n; // DA VEDERE BENE
  backoff(p,nid);
 }
 else  // ccch occupato
 {
 (p+nid)->flag = n;
 (p+nid)->flag2 = n;
 rxctsfromrts(p,nid);
 } // -------------------- FINE PROCEDURA ---------------------------
}/* ---------------------------------------------------------------------*/

/* ----- PROCEDURA PER LA RICEZIONE DEL CTS ---------------------------*/

void rxctsfromrts(nodo* p, int nid)
{
 (p+nid)->n_state = n_rxctsfromrts;
 if((p+nid)->btxcch.state == busy)       // PER L'ATTIVAZIONE IMMEDIATA DEL BRX
 {
  (p+nid)->flag = n;
  remote(p,nid);
 }
 if((p+nid)->flag == n)                   // INIZIALIZZAZIONE DEL TIMER PER LA RICEZIONE
 {
  switch((p+nid)->kind_pkt_ric)
  {
     case r_rts :
       {
        (p+nid)->timer = simul_time +L_RTS;
        (p+nid)->L_NOISE = (L_RTS-1);
        break;
       }
     case r_cts :
       {
        (p+nid)->timer = simul_time + L_CTS;
        (p+nid)->L_NOISE = (L_CTS-1);
        break;
       }
     case r_data :
       {
        (p+nid)->timer = simul_time + L_DATA;
        (p+nid)->L_NOISE = (L_DATA-1);
        break;
       }
     case r_noise :
       {
        (p+nid)->timer = simul_time + (p+nid)->L_NOISE; // da rivedere
        (p+nid)->L_NOISE --;
        break;
       }
  };// -------fine della switch -----------------------------------------
  (p+nid)->flag = y;  //reset per iniz. timer fatta --------------------------
  (p+nid)->wait_flag = y;  // DA VEDERE SE FUNZIONA(RICEVE AL PROSSIMO SLOT)
  return;
 }// FINE INIZIALIZZAZIONE TIMER
 if(simul_time < (p+nid)->timer )
 {
  if((p+nid)->kind_pkt_ric != r_noise)
  {
   (p+nid)->L_NOISE --;
   (p+nid)->wait_flag = y;
   return;
  }
  else // pkt_ric =   noise
  {
   (p+nid)->timer = simul_time + (p+nid)->L_NOISE;
   (p+nid)->L_NOISE --;
   (p+nid)->wait_flag = y;
   return;
  }
 } // FINE DELLA RICEZIONE
 (p+nid)->ccch.state = idle;             // PER RESETTARE IL CANALE DOPO LA RICEZIONE
 (p+nid)->L_NOISE = 0;                   // PER RESETTARE LA LUNGHEZZA DI NOISE PER SUCCESSIVE RICEZ.
 if((p+nid)->kind_pkt_ric == r_cts)
 {
  if((p+nid)->pkt_ric_id == (p+nid)->dest_node_id)
  {                                       // RIC_NODE_ID E' IL DESTINATARIO DEL       // PER BLOCCARE EVENTUALI TX
   yes_cts ++;                            // RTS TX IN PRECEDENZA                     // DI DATA NEL CASO DI BLOCCO
   if((p+nid)->brxcch.state == idle)
   {
    (p+nid)->flag = n;
    (p+nid)->flag2 = n;
    xmit_data(p,nid);
   }
  }
 }
 else // QUALSIASI ALTRA COSA SIA ARRIVATA(compreso non indir. al nodo o brx attivato da un vicino)
 {
  dirty_cts ++;
  (p+nid)->flag = n;
  (p+nid)->flag2 = n;
  (p+nid)->dflag = y;// INIZIALIZZAZIONE DEL DFLAG PER LE CHIAMATE DI REMOTE
  (p+nid)->remote_time = L_DATA + (2*(2*T_MAX))+ELAB_TIME;
  remote(p,nid); // VEDI REGOLE FAMA
 }
} // FINE PROCEDURA DI RICEZIONE DEL CTS



/* ------------------ PROCEDURA XMIT_CTS---------------------------------*/
void xmit_cts(nodo* p , int nid)
{
 int q,t;
 (p+nid)->n_state = n_xmitcts;             // activity_state messo su tra da remote
 if((p+nid)->flag == n)
 {
  (p+nid)->ccch.state = busy;
  (p+nid)->timer = simul_time + L_CTS;
  (p+nid)->flag = y;
  (p+nid)->wait_flag = y;
  return;  //  per aspettare un T_MAX e poi attivare i ccch dei vicini------
 }
 if(simul_time < (p+nid)->timer)
 {
  if((p+nid)->flag2 == n)
  {
   for(t=0;t < ((p+nid)->num_vicini);t++) // QUI IN TEORIA IL CONTROLLO NON SERVE , PERCHE' SE STA TX IL CTS
   {                                      // VUOL DIRE CHE HA RX RTS , QUINDI ALMENO UN VICINO C'E'
    q = (p+nid)->vett_vicini[t];
    if((p+q)->ccch.state == busy)
    {
     (p+q)->kind_pkt_ric = r_noise;
     if((p+q)->L_NOISE < L_CTS)  // dato che tale controllo va fatto
      (p+q)->L_NOISE = L_CTS;    // sia che il nodo stia rx che rx
    }
    else   // CANALE CCCH LIBERO
    {
     (p+q)->ccch.state = busy;
     (p+q)->kind_pkt_ric = r_cts;
     (p+q)->pkt_ric_id = (p+nid)->node_id;// PER IL RICONOSCIMENTO
    }                                     // DEL CTS DA PARTE DEL TX DELL' RTS
   } // del for--------
   (p+nid)->flag2 = y;
  }// del if flag2--------------------------------------------------------
  (p+nid)->wait_flag = y; // per aspettare la fine della tx del cts
  return;
 }  //del if simul_time ---FINE DELLA TRASM. DEL CTS -------------------
 num_xmit_cts++;
 (p+nid)->flag = n;
 (p+nid)->flag2 = n;
 (p+nid)->ccch.state = idle;
 (p+nid)->L_NOISE = 0;
 (p+nid)->dflag = y;// INIZIALIZZAZIONE DEL DFLAG PER LE CHIAMATE DI REMOTE
 (p+nid)->remote_time = (2*(2*T_MAX)) + ELAB_TIME; // DA RICONTROLLARE !!
 remote(p, nid);                //dal FAMA per aspettare il noise o btx o brx-----
}
/*  -----------------FINE PROCEDURA XMIT_CTS----------------------------------*/


/*------------------PROCEDURA XMIT_DATA----------------------------------*/
/*----------------------------------------------------------------------*/
void xmit_data(nodo* p,int nid)
{
 int q,t;
 (p+nid)->n_state = n_xmitdata;
 if((p+nid)->flag == n)
 {
  (p+nid)->timer = simul_time +L_DATA;
  (p+nid)->flag =y;
  (p+nid)->L_NOISE = (L_DATA-1);
  (p+nid)->kind_pkt_ric = r_data;     // per il confronto prima di mettere il canale in idle
  (p+nid)->ccch.state = busy;
  (p+nid)->wait_flag = y;
  return;      //primo ritorno  al prossimo t si attivano iccch dei vicini
 }
 if(simul_time < (p+nid)->timer )
 {
  if((p+nid)->flag2 == n)
  {
   for(t=0;t<(p+nid)->num_vicini;t++)   // STESSO DISCORSO DELLA PROCEDURA XMIT_RTS PER IL CONTROLLO
   {                              // SUL NUMERO DEI VICINI
    q =(p+nid)->vett_vicini[t];
    if((p+q)->ccch.state == busy)
    {
     (p+q)->kind_pkt_ric = r_noise;
     if((p+q)->L_NOISE < L_DATA)
      (p+q)->L_NOISE = L_DATA;
    }//----- da vedere se  poss. altro caso di activity_state----
    else
    {
     (p+q)->ccch.state = busy;
     (p+q)->kind_pkt_ric = r_data;
     (p+q)->pkt_ric_id = (p+nid)->dest_node_id;
    }
   }//-------- fine ciclo for-----------------------------------------
   (p+nid)->flag2 = y;
  } // fine if flag2
  (p+nid)->L_NOISE --;// PER TENERE AGGIORNATO IL CONT DI NOISE DEL TX
  (p+nid)->wait_flag = y;
  return; //------ attesa della fine della tx del data------------------
 }//----------FINE TRASM. DEL PKT DATA------------------------------------
 data_tx ++;
 if((p+nid)->kind_pkt_ric == r_data)
 {
  (p+nid)->ccch.state = idle;      // reset del canale e del noise per la successiva ricez.
  (p+nid)->L_NOISE = 0;
 }
 (p+nid)->pkt_to_tx = not;  // AZZERAMENTO PER POTER TRASM. ALTRO PKT
 (p+nid)->flag = n;
 (p+nid)->flag2 = n;
 passive(p,nid) ; //se si esclude la proc. di backoff-----------------
} /*---------------- fine proc. xmit_data ------------------------------*/




/* ------------------------PROCEDURA XMIT_BROAD--------------------------*/

void xmit_broad(nodo* p, int nid )
{
 (p+nid)->n_state = n_xmitbroad;
 int q,t;
 if((p+nid)->flag == n)
 {
  btx_tra ++; // INCREMENTO CONTATORE TENTATIVI DI PKT_BRO DA TRASMETTERE
  (p+nid)->brx_id = (p+nid)->node_id;
  (p+nid)->timer = simul_time + (2*(2*T_MAX)) +L_CTS + L_DATA;
  (p+nid)->flag = y;
  (p+nid)->wait_flag = y; // SIMULAZIONE TEMPO DI PROP. DEL BTX
  return;
 }
 if(simul_time < (p+nid)->timer)              // ATTESA PER LA TX DEL PKT_B
 {
  if((p+nid)->flag2 == n)  // ATTIVAZIONE DEI BTX DEI VICINI(FASE 2)
  {
   for(t=0;t < (p+nid)->num_vicini;t++)   // IL CONTROLLO SUL NUMERO DEI VICINI E' GIA' FATTO IN FASE
   {                                // DI GENERAZIONE DELL'EVENTO TX
    q =(p+nid)->vett_vicini[t];
    if((p+q)->btxcch.state == idle)
    {
     (p+q)->btx_id = (p+nid)->node_id;
     (p+q)->btxcch.state = busy;    // se  attiva un'altra proc.
    }
    (p+q)->btx_act_count++;         // broad. a 2R
   }//------- fine ciclo for -------------------------------------
   (p+nid)->flag2 = y;
   (p+nid)->wait_flag = y;
   return;
  } // FINE ATTIVAZIONE BTX DEI VICINI(FASE 1 + FASE 2)
  if((p+nid)->brx_id != (p+nid)->node_id)     // INTERRUZIONE PROCEDURA BROADCAST
  {                                           // PER ALTRA A 2R INIZIATA PRIMA
   for(t=0;t<(p+nid)->num_vicini;t++)
   {
    q = (p+nid)->vett_vicini[t];
    if((p+q)->btx_act_count == 1)             // in tal modo attivo broad_off_flag
    {                                        // solo dei nodi coinvolti nella com.
     (p+q)->broad_off_flag = y;
    }  // dell' if btx_act = 1
    else
    {
     (p+q)->btx_act_count --; // gli altri vicini che sentono altra btx
    }
   } // del ciclo for
   interrupt_bro ++;
   (p+nid)->flag = n;
   (p+nid)->flag2 = n;
   (p+nid)->dflag = y;
   (p+nid)->remote_time = L_DATA + (2*(2*T_MAX))+ELAB_TIME; // DA CONTROLLARE BENE !!!!!!!!
	remote(p,nid); //	 ARGOMENTI DI DEFAULT
  } // FINE DEL POSSIBILE CASO DI INTERRUZIONE
  (p+nid)->wait_flag = y;  //--NON SI SONO PRESENTATE INTERRUZ.-> attesa del la tx del pkt_b-
  return;           //  DA VEDERE SE CI VUOLE ELSE CON INTERR.
 } //----------FINE DEL TEMPO DI ATTESA TRA ATT. BTX E TX PKT_B------
 (p+nid)->flag = n;  /* reset del flag   */
 (p+nid)->flag2 = n;
 xmit_pkt_b(p, nid );
}   /*------------------- FINE PROCEDURA------------------------*/

/* ---------------------------------------------------------------------*/


/*-------------------PROCEDURA XMIT_PKT_B----------------------------------*/
void xmit_pkt_b(nodo* p,int nid)
{
 (p+nid)->n_state = n_xmitpktb;
 int q,t;
 if((p+nid)->flag == n)
 {
  (p+nid)->broad_ok = y;
  pkt_b_tra ++;
  (p+nid)->timer = simul_time + (2*T_MAX) +((NUMERO_SLOT+1)*((2*T_MAX) + L_PKT_B)); //OK
  (p+nid)->timer2 = simul_time + L_PKT_B;
  (p+nid)->flag = y;
  (p+nid)->wait_flag = y; // SIMUL. TEMPO DI PROPAG.
  return;
 }
 if(simul_time < (p+nid)->timer )// per tutto il ciclo di una tx broad.
 {
  if(simul_time < (p+nid)->timer2) // per la tx effettiva del pkt_b
  {
   if((p+nid)->flag2 == n) // TRASMISSIONE PKT_B (FASE 2)
   {
    (p+nid)->flag2 = y;
    for(t=0;t<(p+nid)->num_vicini;t++)
    {
     q = (p+nid)->vett_vicini[t];
     (p+q)->ccch.state = busy;
     (p+q)->kind_pkt_ric = r_pkt_b;
    }// del for
   } // dell' if flag2
   (p+nid)->wait_flag = y;
   return;
  } //FINE TRASMISSIONE PKT_B(FASE1 + FASE2)-> ATTESA DELLE RISPOSTE
  if((p+nid)->flag3 == n) // CONTROLLO SUI PKT_B ARRIVATI A DESTINAZIONE
  {
   if((p+nid)->broad_ok == y)
   {
     pkt_arrived_bro ++;
   }
   else
   {
    pkt_bro_not ++;
   }
   (p+nid)->flag3 = y;
  }// del flag3
  (p+nid)->wait_flag = y;
  return;
 } // FINE TEMPO TOTALE DELLA TRASMISSIONE BROADCAST (PKT_B + ANSWER)
 (p+nid)->brxcch.state = idle;
 (p+nid)->brx_act_count = 0;
 (p+nid)->ccch.state = idle;
 (p+nid)->L_NOISE = 0;
 (p+nid)->pkt_to_tx = not; // AZZERAMENTO DI PKT_TO_TX PER POTER TX ALTRO PACCHETTO
 (p+nid)->flag = n;    // reset dei flag ------------------------------------
 (p+nid)->flag2 = n;    // EVENTUALE CHIAMATA DI BACKOFF
 (p+nid)->flag3 = n;
 passive(p, nid );
} /*------------- fine procedura  --------------------------------------*/


/*  -------- PROCEDURA XMIT_ANSWER -------------------------------------*/

void xmit_answer(nodo* p,int nid )
{
 int t,q;
 (p+nid)->n_state = n_xmitanswer ;
 if((p+nid)->flag == n)
 {
  (p+nid)->kind_pkt_ric = r_data; //per controllo su arrivo pkt_b
  (p+nid)->timer = simul_time +((NUMERO_SLOT)*((2*T_MAX) + L_PKT_B))+L_ANSWER;
  (p+nid)->flag = y;
 }
 if(simul_time < (p+nid)->timer )
 {
  (p+nid)->wait_flag = y; // simulazione tx sul acch
  return;
 } // TRASMISSIONE DELLA RISPOSTA TERMINATA
 for(t=0;t<(p+nid)->num_vicini;t++)// DISATTIVAZIONE BRX DEI VICINI(FASE 2)
 {
  q = (p+nid)->vett_vicini[t];
  if((p+q)->brx_act_count > 0)
  {
   if((p+q)->brx_act_count == 1)
     (p+q)->brxcch.state = idle;
   (p+q)->brx_act_count --;
  }
 } // del for
 (p+nid)->btxcch.state = idle;
 (p+nid)->btx_act_count = 0;
 (p+nid)->ccch.state = idle;
 (p+nid)->L_NOISE = 0;
 (p+nid)->flag = n;
 (p+nid)->remote_time = L_DATA + (2*(2*T_MAX)) + ELAB_TIME;
 (p+nid)->dflag = n;
  remote(p,nid);
}
/*-------------------------- FINE PROCEDURA ------------------------*/


/*-------- PROCEDURA PER L'ATTESA DEL PKT_B --------------------------*/

void wait_pktb(nodo* p, int nid)
{
 int t,q;
 (p+nid)->n_state = n_waitpktb;
 if((p+nid)->flag == n)
 {
  (p+nid)->ccch.state = idle;
  (p+nid)->timer = simul_time + L_DATA+L_CTS + (2*(2*T_MAX));
  (p+nid)->flag = y;
 }
 if(((p+nid)->broad_off_flag == n)&&((p+nid)->ccch.state == idle )&&(simul_time <= (p+nid)->timer))
 {
  (p+nid)->wait_flag = y;
  return;
 }
 else if((p+nid)->broad_off_flag == y)
 {                                    // IL BROAD_OFF_FLAG VIENE ATTIVATO SOLO PER I NODI CHE SENTONO
  for(t=0;t<(p+nid)->num_vicini;t++)
  {
   q = (p+nid)->vett_vicini[t];
   if((p+q)->brx_act_count > 0)
   {                                  // controllato ogni volta
    if((p+q)->brx_act_count == 1)     // che si entra nella parte
     (p+q)->brxcch.state = idle;      // btxcch = busy
    (p+q)->brx_act_count --;
   }
  }// del for
  (p+nid)->btxcch.state = idle;// per forza ha btx_count = 1
  (p+nid)->btx_act_count = 0;
  (p+nid)->flag = n;
  (p+nid)->broad_off_flag = n;
  (p+nid)->dflag = y;   // DA RICONTROLLARE ACCURATAMENTE
  (p+nid)->remote_time = L_DATA + (2*(2*T_MAX)) +ELAB_TIME;
  remote(p,nid);
 } // fine del CASO D'INTERRUZIONE DELLA PROC. BROAD.
 else if(simul_time > (p+nid)->timer)// timer scaduto e/o pkt_b non arrivato
 {
  int x;
  x = (p+nid)->btx_id;
  if((p+x)->broad_ok == y)
    (p+x)->broad_ok = n;
  (p+nid)->flag = n;
  (p+nid)->dflag = y;
  (p+nid)->remote_time = L_DATA + (2*(2*T_MAX));
  remote(p,nid);
 }
 else //((p+nid)->ccch.state == busy)
 {
   (p+nid)->flag = n;
   xmit_answer(p,nid );
 }
}  // FINE CASO DI ATTESA DEL PKT_B
 // -------- FINE PROCEDURA PER ATTESA PKT_B -----------------------------------





/*--------------------- PROCEDURA REMOTE -----------------------------*/

void remote(nodo* p,int nid ) //DA VERIFICARE GLI ARGOMENTI DI DEFAULT
{
 int q,t; //---- per attivazione brx dei vicini --------------------------
 (p+nid)->n_state = n_remote;
 if((p+nid)->btxcch.state == busy) // ----1 CASO -------------------------
 {
  if((p+nid)->flag2 == n)//--- FASE ATTIV. BRX DOPO AVER SENTITO BTX ON(FASE 1)
  {
   (p+nid)->flag2 = y;
   (p+nid)->wait_flag = y;     // SIMULAZIONE DEL TEMPO DI PROPAGAZIONE
   return;
  }//flag2
  for(t=0;t<(p+nid)->num_vicini;t++)//ATTIVAZIONE BRX DOPO AVER SENTITO BTX (FASE 2)
  {
   q =(p+nid)->vett_vicini[t];
   if((p+q)->brxcch.state == idle)
     (p+q)->brxcch.state = busy;
   if((p+q)->brx_id != (p+nid)->btx_id)
     (p+q)->brx_id = (p+nid)->btx_id; // quello ricevuto dal tx broad.
   (p+q)->brx_act_count ++;
  }// del for */
  (p+nid)->flag2 = n;
  wait_pktb(p,nid);
 }// fine caso btxcch busy
 if((p+nid)->flag == n)
 {
  (p+nid)->timer = simul_time + (p+nid)->remote_time;
  (p+nid)->flag = y;
 }
 if(((p+nid)->ccch.state == idle)&&(simul_time <= (p+nid)->timer))
 {
  (p+nid)->wait_flag = y;
  return;
 }
 else if(simul_time > (p+nid)->timer)
 {
  if((p+nid)->pkt_to_tx == yes)          // ---2 CASO ---------------------------
  {                                      // IL CONTROLLO SUI 2 TONI PER EVITARE ALLUNGAMENTI
   (p+nid)->back_flag =n ;
   (p+nid)->flag = n;
   backoff(p,nid);
  } // dell' if pkt_to_tx = yes
  else // pkt_to_tx = not
  {
   (p+nid)->flag = n;
   passive(p,nid);
  }
 } //----------------- FINE DEL 2 CASO--------------------------------------
 else if((p+nid)->ccch.state == busy) // ----- 3 CASO -------------------------
 {
  (p+nid)->flag = n;             // DA VEDERE DISATT. DI ALTRI FLAG
  rx_from_remote(p,nid);   // DA VEDERE MOLTO BENE  !!!!!!
 }
} //---------------- FINE PROCEDURA REMOTE ---------------------------------




/*------- PROCEDURA DI RICEZIONE DA REMOTE --------------------------------*/
void rx_from_remote(nodo* p, int nid)
{
 (p+nid)->n_state = n_rxfromremote;
 if((p+nid)->btxcch.state == busy)
 {                                      // PER ATTIVAZIONE IMMEDIATA
  remote(p,nid);
 }
 if((p+nid)->flag == n) // FASE DI INIZIALIZZAZIONE DEL TIMER PER
 {                      // LA RICEZIONE
  switch((p+nid)->kind_pkt_ric)
  {
    case r_rts :
      {
       (p+nid)->timer = simul_time +L_RTS;
       (p+nid)->L_NOISE = (L_RTS-1);
	   break;
      }
    case r_cts :
      {
      (p+nid)->timer = simul_time + L_CTS;
	   (p+nid)->L_NOISE = (L_CTS-1);
       break;
      }
    case r_data :
      {
  	   (p+nid)->timer = simul_time + L_DATA;
	   (p+nid)->L_NOISE = (L_DATA-1);
       break;
      }
    case r_noise :
      {
      (p+nid)->timer = simul_time + (p+nid)->L_NOISE; // da rivedere
	   (p+nid)->L_NOISE --;
       break;
      }
  };// -------fine della switch -----------------------------------------
  (p+nid)->wait_flag = y;
  (p+nid)->flag = y;  //reset per iniz. timer fatta --------------------------
  return;
 }  // ------- INIZIAL. TIMER PER RX TERMINATA ----------------------------------------
 if(simul_time < (p+nid)->timer)                // INIZIA LA FASE DI
 {                                              // RICEZIONE SUL CCCH
  if((p+nid)->kind_pkt_ric != r_noise)
  {
   (p+nid)->L_NOISE --;
   (p+nid)->wait_flag = y;
   return;
  }
  else //  pkt_ric =  noise
  {
   (p+nid)->timer = simul_time + (p+nid)->L_NOISE;
   (p+nid)->L_NOISE --;
   (p+nid)->wait_flag = y;
   return;
  }
 } // FASE DELLA RICEZIONE TERMINATA- DECISIONI IN BASE AL PACCHETTO ARRIVATO
 (p+nid)->L_NOISE = 0;   // reset per le successive ricez.
 (p+nid)->ccch.state = idle;     //NOTA BENE!!: per rimettere il canale in idle
 switch((p+nid)->kind_pkt_ric)
 {
   case r_rts :      // DA VEDERE COME AGGANCIARE ALLA RICHIAMATA DI REMOTE
     {
      if((p+nid)->dflag == y)
      {
       (p+nid)->flag = n;
	    remote(p, nid);     // CONTROLLO SUBITO DOPO LA RX E PRIMA DI TX
      }
      if((p+nid)->pkt_ric_id == (p+nid)->node_id)
      {
       yes_rts ++;
       if((p+nid)->brxcch.state == idle)
       {
        (p+nid)->flag = n;
        xmit_cts(p,nid);// la chimata di remote(FAMA) la fa xmit_cts-
       }
      }
      else  // RTS DIRETTO AD UN ALTRO NODO
      {
       (p+nid)->flag = n;
       (p+nid)->dflag = y;
	    (p+nid)->remote_time =  (4*(2*T_MAX)) + L_CTS+ELAB_TIME;
	    remote(p,nid);
      }
      break;
     }
   case r_cts :
     {
      (p+nid)->flag = n;
      (p+nid)->dflag = y;
	   (p+nid)->remote_time = L_DATA +(2*(2*T_MAX))+ELAB_TIME;
	   remote(p,nid );
      break;
     }
   case r_data :
     {
	   if((p+nid)->pkt_ric_id == (p+nid)->node_id)
        pkt_arrived_dir ++;           // CONTATORE PACCHETTI DATA
      (p+nid)->flag = n;              // ARRIVATI A DESTINAZIONE
      (p+nid)->dflag = y;
	   (p+nid)->remote_time = L_CTS + (2*(2*T_MAX))+ELAB_TIME;
	   remote(p,nid);
      break;
     }
   case r_noise :
     {
	   (p+nid)->flag = n;
      (p+nid)->dflag = y;
	   (p+nid)->remote_time =  L_DATA +(2*(2*T_MAX))+ELAB_TIME;
	   remote(p,nid );
      break;
     }
 }; //--------------fine dello switch -----------------------------------
} /* ----------------- FINE PROCEDURA ------------------------------------*/
/*---------------------- PROCEDURA MAIN ----------------------------------*/
int main()
{
 nodo* punt;
 int global_time , num_nodi,prova_fine;
 int a ,b ,c,/*w,*/ temp2,s;
 cout << "inserisci il numero dei nodi : \n";
 cin >> num_nodi;
 if(num_nodi >= (MAX_AREA*MAX_AREA))
 {
  cout << " il numero dei nodi supera quello consentito che  di:\n" << (MAX_AREA*MAX_AREA);
  exit(EXIT_FAILURE);
 }
 cout << "inserisci il tempo di simulazione(in interi):\n";
 cin >> global_time;
 for(s=0;s<NUMERO_PROVE;s++)
 {
  punt = crea_vettore_rete(num_nodi);  // CREAZIONE VERA E PROPRIA DELLA RETE
  assign_coordinate(punt , num_nodi);  // TRAMITE LE FUNZIONI DEFINITE
  make_vett_vicini(punt , num_nodi);   //ALL' INIZIO DEL FILE
  last_tx_time = -DELTA_TIME;          //per la prima trasmissione
  randomize();
  for(simul_time = 0; simul_time <= global_time; simul_time++)
  {
   if((simul_time - last_tx_time) >= DELTA_TIME)
   {
    int i,j, k=0;
    set_tx_flag = not_ok; // inizial. flag per attivazione nodo tx
    temp2 =0;//random(2);
    if(temp2 == 0)
     sgn = direct;
    else
     sgn = broadcast;
    for(i=0;i<num_nodi;i++)
    {
     one_bro = ok;
     if(((punt+i)->pkt_to_tx == not)&&((punt+i)->num_vicini > 0)&&(one_bro == ok))  // si potrebbe fare il controllo
      k++;                                                         // su p->pkt_to_tx se  yes
    }                                                              // non si attiva, se  not si
    if(k>0)  // se k<0 vuol dire che non c'e' nessun nodo disponibile per accettare un pkt da tx                                                      // attiva
    {
     last_tx_time = simul_time;
     do
     {
      a = random(num_nodi );// non arriva mai a num_nodi
      one_bro = ok;
      if(((punt+a)->pkt_to_tx == not)&&((punt+a)->num_vicini > 0)&&(one_bro == ok))// --punt  il punt che restituisce la funzione TOP_MATR--
      {
       set_tx_flag = ok;
       if( sgn == broadcast )
       {
        (punt+a)->pkt_to_tx = yes;
        (punt+a)->kind_of_sgn = broadcast;
	     pkt_try_to_send_bro ++;// INCREMENTO DEL CONTATORE DI PKT_BRO MANDATI DA TX DALLO STRATO SUP
       }                       // ALLO STRATO MAC
       else
       {
        (punt+a)->pkt_to_tx = yes;
        pkt_try_to_send_dir ++;// INCREMENTO DEL CONTATORE DI PKT_DATA MANDATI DA TX DALLO STRATO SUP
        (punt+a)->kind_of_sgn = direct;
        b = random((punt+a)->num_vicini);
        (punt+a)->dest_node_id = (punt+a)->vett_vicini[b];
       }
      }
     } // --blocco del do-while--
     while( set_tx_flag != ok );
    }// if k>0  -- SE K<0 NON GENERA UN EVENTO TX
   } //  fine dell' if simul_time - last_tx_time
   /* ------------inizio ciclo che scorre tutti i nodi------------ */
   /* ------------all'interno del for(simul_time)--------------- */
   /* ----- FINE PARTE PER EVENTUALE GENERAZIONE DI UN -------------*/
   /* ---------------- EVENTO TRASMISSIVO ---------------------------*/

   for( c=0; c<num_nodi ;c++) // --applicazione delle regole del protocollo per ogni nodo-----
   {
    if( (punt+c)->n_state == n_passive)
    {
     passive(punt,c);
     if( (punt+c)->wait_flag != n)
     {
      (punt+c)->wait_flag = n;
      continue;
     }
    }
    else if( (punt+c)->n_state == n_backoff)
    {
     backoff(punt,c);
     if( (punt+c)->wait_flag != n)
     {
      (punt+c)->wait_flag = n;
      continue;
     }
    }
    else if((punt+c)->n_state == n_xmitrts)
    {
     xmitrts(punt,c);
     if( (punt+c)->wait_flag != n)
     {
      (punt+c)->wait_flag = n;
      continue;
     }
    }
    else if((punt+c)->n_state == n_rts)
    {
     rts(punt,c);
     if((punt+c)->wait_flag == y)
     {
      (punt+c)->wait_flag = n;
      continue;
     }
    }
    else if((punt+c)->n_state == n_rxctsfromrts)
    {
     rxctsfromrts(punt,c);
     if((punt+c)->wait_flag == y)
     {
      (punt+c)->wait_flag = n;
      continue;
     }
    }
    else if( (punt+c)->n_state == n_xmitcts)
    {
     xmit_cts(punt,c);
     if( (punt+c)->wait_flag != n)
     {
      (punt+c)->wait_flag = n;
      continue;
     }
    }
    else if( (punt+c)->n_state == n_xmitdata)
    {
     xmit_data(punt,c);
     if( (punt+c)->wait_flag != n)
     {
      (punt+c)->wait_flag = n;
      continue;
     }
    }
    else if( (punt+c)->n_state == n_xmitbroad)
    {
     xmit_broad(punt,c);
     if( (punt+c)->wait_flag != n)
     {
      (punt+c)->wait_flag = n;
      continue;
     }
    }
    else if( (punt+c)->n_state == n_xmitpktb)
    {
     xmit_pkt_b(punt,c);
     if( (punt+c)->wait_flag != n)
     {
      (punt+c)->wait_flag = n;
      continue;
     }
    }
    else if( (punt+c)->n_state == n_xmitanswer)
    {
     xmit_answer(punt,c);
     if( (punt+c)->wait_flag != n)
     {
      (punt+c)->wait_flag = n;
      continue;
     }
    }
    else if( (punt+c)->n_state == n_remote)
    {
     remote(punt, c ); // FORSE ARGOMENTI DI DEFAULT ???????
     if( (punt+c)->wait_flag != n)
     {
      (punt+c)->wait_flag = n;
      continue;
     }
    }
    else if((punt+c)->n_state == n_rxfromremote)
    {
     rx_from_remote(punt,c);// FORSE ARGOMENTI DI DEFAULT
     if((punt+c)->wait_flag == y)
     {
      (punt+c)->wait_flag = n;
      continue;
     }
    }
    else if((punt+c)->n_state == n_waitpktb)
    {
     wait_pktb(punt,c);
     if((punt+c)->wait_flag == y)
     {
      (punt+c)->wait_flag = n;
      continue;
     }
    }
   } /* ---------fine ciclo for che scorre tutti i nodi ?????---------- */
 /* ------------------------------------------------------------------- */
 /* ------------------------------------------------------------------- */
 /* -------- altre istruzioni nel ciclo di simul_time---------------- */
 /* ------------------------------------------------------------------- */
 /* ------------------------------------------------------------------- */

  } /* -------fine ciclo simul_time---------------------------------- */
  delete(punt);
 }  // FINE CICLO NUMERO PROVE
 dir_throug = (float)pkt_arrived_dir/pkt_try_to_send_dir;
 bro_throug = (float)pkt_arrived_bro/pkt_try_to_send_bro;
 cout << "tx broadcast arrivate/partite :"<<pkt_arrived_bro<<"/"<<pkt_try_to_send_bro<<"\n"<<
         "th bro:"<<bro_throug<<"\n"<<
         "il num di btx tentati e':"<<btx_tra<<"\n"<<
         "il num di pktb tra e' :"<< pkt_b_tra <<"\n" <<
         "il num di pkt_b non arrivati e' : "<< pkt_bro_not << "\n"<<
         "il num di tx bro interrotte dal meccanismo brx_id sono :"<< interrupt_bro <<"\n" <<
         "tx dirette arrivate/partite :"<<pkt_arrived_dir<<"/"<<pkt_try_to_send_dir<<"\n"<<
         "il num di rts trasmessi e' :" <<num_rts<<"\n" <<
         "th dir:"<<dir_throug<<"\n";
 cin >> prova_fine;
 while(prova_fine != 0)
   ;
 return(0);
}  /* -----------------FINE DELLA MAIN--------------------------------*/