
/*------------ SIMULATORE PER LA GESTIONE DEL CANALE ACCH PER LE -------------*/
/*------------ RISPOSTE AD UNA TRASMISSIONE BROADCAST(DBTMA/FAMA)-------------*/

#include <stdlib.h>/*per exit(), rand(), .......    */
#include <iostream.h> /* per NULL   */
#include <math.h> /* per le funzioni per la creazione della topologia */
#include <time.h>
const int  T_MAX =1 ;
const int NUMERO_SLOT = 50;
const int MAX_AREA = 10;
const int R_MAX =2.0;
enum FLAG {n,y};

class nodo
{
 public :
  int  node_id;
  int num_vicini;
  int coord_x,coord_y;
  FLAG flag ,flag2 , flag3 ,flag4; // DA VERIFICARE SE NE OCCORRONO ALTRI
  int* vett_vicini;
 };


float node_distance(nodo* n1, nodo* n2)
{
 float distance;
 int k,m,n,l;
 k = (n1->coord_x);
 m = (n2->coord_x);
 n = (n1->coord_y);
 l = (n2->coord_y);
 distance = sqrt( pow((k-m), 2) +pow((n-l), 2));
 return distance;
}

/*-------------- FINE FUNZIONI AUSILIARIE --------------------------*/


/*-------- PROCEDURA DI CREAZIONE DEL VETTORE DEI NODI ------------*/

nodo* crea_vettore_rete(int numero_nodi)
{
 int i;
 nodo* p = new nodo[numero_nodi];
 if( p== NULL)
 {
  cout << "non  stata allocata memoria per p. \n";
  exit(EXIT_FAILURE);
 }
 for(i=0;i<numero_nodi;i++) // fase inizializzazione dei campi del
 {                          // del vettore dei nodi escluse le coord
  (p+i)->node_id = i;
  (p+i)->flag = n;
  (p+i)->flag2 = n;
  (p+i)->flag3 = n;
  (p+i)->flag4 = n;
 }
 return p;
}

/*------------- FINE CREAZIONE DEL VETTORE DEI NODI -------------------*/


/*-------- PROCEDURA DI CREAZIONE DELLA TOPOLOGIA -------------------*/
/* ------ NUOVA PROCEDURA DI ASSEGNAZIONE DELLE COORDINATE-----------*/

void assign_coordinate(nodo* p, int numero_nodi)
{
 int i , j , num_nodi_act = 0;
 int* matrix;
 matrix = new int[(MAX_AREA)*(MAX_AREA)];
 if( matrix == NULL )
 {
  cout << "memoria non allocata per matrix. \n";
  exit(EXIT_FAILURE);
 }
 for(i=0;i<MAX_AREA;i++)
 {
  for(j=0;j<MAX_AREA;j++)
   *(matrix +i*MAX_AREA + j) = 0;  // INIZIALIZZAZIONE DELLA MATRICE
 } // FINE CICLI DI INIZIALIZZAZIONE
 randomize();// messo qui il tempo per la generazione delle coord  molto minore
 while(num_nodi_act < numero_nodi)
 {
  i = random(MAX_AREA);   // RESTITUISCE INTERO TRA 0 E (MAX_AREA-1)
  j = random(MAX_AREA);
  if(*(matrix +i*MAX_AREA + j) == 0)   // CREAZIONE MATRICE RANDOM
  {                                    // PER L'ASSEGNAZIONE DELLE COORDINATE
   *(matrix + i*MAX_AREA +j) = 1;
   num_nodi_act ++;
  }
 }
 num_nodi_act = 0;
 do
 {
  for(i=0;i<MAX_AREA;i++)
  {
   for(j=0;j<MAX_AREA;j++)
   {
    if(*(matrix + i*MAX_AREA  + j) == 1)
    {
     (p + num_nodi_act)->coord_x = i;
     (p + num_nodi_act)->coord_y = j;
     num_nodi_act ++;
    }
   }
  }
 } // FINE BLOCCO DO
 while(num_nodi_act < numero_nodi); // FINE ASSEGNAZIONE COORDINATE
 delete(matrix);
}

/*---- FINE DELLA PROCEDURA DI ASSEGNAZIONE DELLE COORDINATE --------*/

/*------- PROCEDURA PER RIEMPIMENTO CAMPI DEL VETT_VICINI ---------------*/


void make_vett_vicini(nodo* p, int numero_nodi)
{
 int i,tot_vicini,j,temp;
 for(i=0;i<numero_nodi;i++)
 {
  tot_vicini=0;
  for(j=0;j<numero_nodi;j++)
  {
   if(i != j)
   {
    if(node_distance((p+i) , (p+j)) <= R_MAX )
     tot_vicini++;
   }
  } // del for j
  (p+i)->num_vicini = tot_vicini;
  if(tot_vicini >= 1)                           // SE k> 0 NON VIENE ALLOCATO IL VETTORE DEI VICINI
  {                                    // IL CONTROLL0 VA ESEGUITO OGNI VOLTA CHE SI DEVONO ATTIVARE I CAMPI
   (p+i)->vett_vicini = new int[tot_vicini]; // DEI VICINI SIA in tx che in rx
   temp=(tot_vicini-1);
   for(j=0;j<numero_nodi;j++)
   {
    if(i != j)
    {
     if(node_distance((p+i) , (p+j)) <= R_MAX )
     {
      (p+i)->vett_vicini[temp] = j;
      temp--;
     }
    } //del if i != j
   } // del for j
  } // del if k>=1
 }// del for i
} // fine make_vett

/*------- FINE PROCEDURA RIEMPIMENTO VETT_VICINI PER TUTTI I NODI --------*/

int main()
{
 int fine,num_nodi,numero_prove,i,t,q,a,j;
 int vett_slot[NUMERO_SLOT];
 float vicini_not_answer ;
 int temp2 = 0;
 int vic_temp = 0;
 float per_not_answer;
 float vic_media;
 nodo* p;
 cout << "inserisci il numero di nodi : \n";
 cin >> num_nodi;
 cout << "inserisci il numero di prove : \n";
 cin >> numero_prove;
 p = crea_vettore_rete(num_nodi);
 assign_coordinate(p,num_nodi);
 make_vett_vicini(p,num_nodi);
 for(i=0;i<num_nodi;i++)
 {
   vic_temp += (p+i)->num_vicini;
 }
 vic_media = (float)vic_temp/num_nodi;
 for(i=0;i<numero_prove;i++) // una prova = una trasmissione broadcast
 {
  for(j=0;j<NUMERO_SLOT;j++)// reset del vettore degli slot
  {
   vett_slot[j] = 0;
  }
  a = random(num_nodi);
  for(t=0;t<(p+a)->num_vicini;t++)
  {
    q = random(NUMERO_SLOT);
    vett_slot[q]++;
  }
  for(j=0;j<NUMERO_SLOT;j++)
  {
   if(vett_slot[j] > 1)
     temp2 += vett_slot[j];  // temp2 raccoglie la somma di vicini le cui risposte hanno colliso
  }// del for                // considerando tutte le trasmissioni broadcast(prove)
 }// del for
 vicini_not_answer = (float)temp2/numero_prove;// vicini che in media per ogni tx non hanno risposto
 per_not_answer = vicini_not_answer/vic_media;
 cout << "il numero di vicini in media non ha risposto e' :"<< vicini_not_answer<<"\n"<<
         "la media di vicini per nodo e' :"<<vic_media <<"\n" <<
         "la percentuale di vicini per tx broad che non ha risposto e' :"<< ((per_not_answer)*100)<<"%"<<"\n" ;
 cin >> fine;
 delete(p);
 while(fine != 0)
   ;
 return(0);
}
